<?php

if (!defined('_PS_VERSION_')) {
    exit;
}

class VenipakcarrierVenipakcontModuleFrontController extends ModuleFrontController {


    /**
     * <p>Exits script with message not logged in message when user is not logged in as admin.</p>
     */

    private $_module = NULL;
    public $module = 'venipakcarrier';
    public function __construct() {

        $context = Context::getContext();
        $cookie = new Cookie ('psAdmin');
        $employee = new Employee ($cookie->id_employee);
        $context->employee = $employee;
        $context->cookie = $cookie;
        if(!Context::getContext()->employee->isLoggedBack()){
            exit('Restricted.');
        }

        $this->_module = new VenipakCarrier();
        $this->module = 'venipakcarrier';

        $this->parseActions();
        parent::__construct();
        //exit();
    }

    private function parseActions(){
        $action = Tools::getValue('action');

        switch($action){
            case 'saveveniorder': $this->saveVeniOrder(); break;
            case 'popup': $this->renderPopup(); break;
            case 'printlabels': $this->printLabels(); break;
            case 'printmanifest': $this->printManifest(); break;
            case 'callcarrier': $this->callCarrier(); break;
        }
    }


    protected function renderPopup(){
        global $smarty;
        $context = Context::getContext();

        $warehouses = $this->_module->getWarehouses();
        $manifests = array();
        $courrierCallToday = array();
        foreach($warehouses as $wh){
            //$openOrders = $this->_module->getOpenOrders($wh['id']);
            VenipakCarrier::checkForClass('VeniOrder');
            $openOrdersObj = new VeniOrder();
            $openOrders = $openOrdersObj->getOrders($wh['id'], (int)$context->language->id);
            $manifests[$wh['id']] = $openOrders;

            
            $courrierCalls[$wh['id']] = $this->_module->getCarrierCallFromDate($wh['id'], date('Y-m-d'));
            if($courrierCalls[$wh['id']]){
                //parse saved JSON data
                foreach($courrierCalls[$wh['id']] as $key=>$val){
                    $courrierCalls[$wh['id']][$key]['data_parsed'] = json_decode($courrierCalls[$wh['id']][$key]['call_data'], true);
                }
                
            }
        }

        //create dates for calling couries
        $couriesCallDates = array();
        $weightsByWarehouseByManifest = array();
        $datetime = new DateTime(date('Y-m-d'));
        for($i=0;$i<5;$i++){
            $date = $datetime->format('Y-m-d');
            $couriesCallDates[]=array('date'=>$date);
            $datetime->modify('+1 day');

            //add weights
            foreach($warehouses as $wh){
                $weight = $this->_module->getTotalWeightByDate($date);
                $weightsByWarehouseByDate[$wh['id']][$date]=$weight;
            }
        }

        foreach($couriesCallDates as $key=>$d){
            $tmpDate = new DateTime(date('Y-m-d'));
            $tmpDate->modify('+1 day');
            if($d['date']==date('Y-m-d')){ //today, calculate only from NOW
                $datetime = new DateTime(date('Y-m-d'));
                $datetime->setTime(date('H'), 0, 0);
                $datetime->modify('+1 hour');
                $tmpDate->modify('-9 hour');
            }else{
                $datetime = new DateTime($d['date']);
                $tmpDate = new DateTime($d['date']);
                $datetime->setTime(8, 0, 0);
                $tmpDate->setTime(23,0,0);

            }

//            while($datetime->format('Y-m-d H:i:s')<$tmpDate->format('Y-m-d H:i:s')){
//                $nextDate = new DateTime($datetime->format('Y-m-d H:i:s'));
//                $nextDate->modify('+2 hour');
//                $couriesCallDates[$key]['times'][$datetime->format('H:i').'-'.$nextDate->format('H:i')]=$datetime->format('H:i').'-'.$nextDate->format('H:i');
//                $datetime->modify('+2 hour');
//            }
            //times
            for($i=$datetime->format('G'); $i<23; $i++){
                $couriesCallDates[$key]['times']['hours'][]=$i;

            }
            for($i=$datetime->format('i'); $i<60; $i=$i+15){
                $couriesCallDates[$key]['times']['mins'][]=$i;
            }
        }

        //check if courier was called today

        $smarty->assign(array(
            'veni_warehouses' => $warehouses,
            'manifests' => $manifests,
            'printlabelsurl'=>$context->link->getModuleLink('venipakcarrier', 'venipakcont',array('action'=>'printlabels')),
            'callcarrierurl' => $context->link->getModuleLink('venipakcarrier', 'venipakcont',array('action'=>'callcarrier')),
            'printmanifesturl' => $context->link->getModuleLink('venipakcarrier', 'venipakcont',array('action'=>'printmanifest')),
            'allmanifestslink' => $context->link->getAdminLink('AdminVenipak'),

            'couries_call_dates'=>$couriesCallDates,
            'weights_by_warehouse_by_date' => $weightsByWarehouseByDate,
            'courrierCalls' => $courrierCalls
        ));
        echo $smarty->fetch(_PS_MODULE_DIR_.$this->_module->name.'/tpl/'.'popup.tpl');
        exit();
    }

    protected function saveVeniOrder(){
        if(!empty($this->_module->warning)){
            return false;
        }
        $orderId = Tools::getValue('order_id', NULL);
        $order = new Order((int)$orderId);
        if(!$order){
            return false;
        }
        VenipakCarrier::checkForClass('VeniOrder');
        $veniOrderObj = new VeniOrder();
        $saveResult = $veniOrderObj->saveVeniOrder();

        if(isset($saveResult['success'])){
            //call venipak API to save order with packs
            VenipakCarrier::checkForClass('VenipakAPI');
            $venipakAPI = new VenipakAPI($this->_module);
            $venipakResult = $venipakAPI->sendShipmentXML(array($saveResult['success']));
            if(is_array($venipakResult) && isset($venipakResult['success'])){
                $orderStatus = Configuration::get('VENIPAK_ORDER_STATUS');
                if($orderStatus!=''){
                    //change order status
                    $history = new OrderHistory();
                    $history->id_order = (int)$orderId;
                    $history->changeIdOrderState((int)($orderStatus), (int)$orderId);
                }
                //set tracking number
                $trackingNo = VeniOrder::getFirstPack($orderId);
                Db::getInstance()->update('order_carrier', array('tracking_number' => $trackingNo), 'id_order = '.(int)$orderId);

            }else{
                //DELETE order data
                $veniOrderObj->deleteOrderData((int)$orderId);
            }
            echo json_encode($venipakResult); exit();
        }
        echo json_encode($saveResult); exit();
    }

    /**
     * Call API to get label PDF.
     */
    protected function printLabels(){
        $orderIds = $_POST['order_ids'];
        if(empty($orderIds) || !is_array($_POST['order_ids'])){
            echo json_encode(array('error'=>'No order ID provided.'));
        }


        VenipakCarrier::checkForClass('VenipakAPI');
        $apiClass = new VenipakAPI($this->_module);

        $result = $apiClass->getLabelsForOrders($orderIds);
        if(is_array($result)){
            $type = $result['type'];
            $content = $result['result'];
        }else{
            echo "Error occured.";
            exit();
        }
        header('Content-type: application/'.$type);
        header('Content-Disposition: attachment; filename="venipak-labels.'.$type.'"');
        header('Content-Transfer-Encoding: binary');
        header('Accept-Ranges: bytes');
        if($type=='zip'){
            echo readfile($content);
        }else{
            echo $content;
        }
        exit();

    }

    protected function printManifest(){
        if(!isset($_POST['manifest_no']) || !is_numeric($_POST['manifest_no'])){
            echo "Invalid manifest no.";
            exit();
        }
        $manifestNo = trim($_POST['manifest_no']);
        VenipakCarrier::checkForClass('VenipakAPI');
        $apiClass = new VenipakAPI($this->_module);
        $result = $apiClass->getManifestFile($manifestNo);
        if(strlen($result)>20){
            //close manifest
            VenipakCarrier::checkForClass('VeniManifest');
            $manifestObj = new VeniManifest();
            $manifestObj->closeManifest($manifestNo);
        }
        header('Content-type: application/pdf');
        header('Content-Disposition: attachment; filename="venipak-manifest-'.$manifestNo.'.pdf"');
        header('Content-Transfer-Encoding: binary');
        header('Accept-Ranges: bytes');
        echo $result;
        exit();
    }

    protected function callCarrier(){

        $weight = trim(Tools::getValue("weight",""));
        $pallets = trim(Tools::getValue("pallets",""));
        $comment = trim(Tools::getValue("comment",""));
        $arrive_date = trim(Tools::getValue('arrive_date'));
        $hour_from = trim(Tools::getValue('hour_from'));
        $min_from = trim(Tools::getValue('min_from'));
        $hour_to = trim(Tools::getValue('hour_to'));
        $min_to = trim(Tools::getValue('min_to'));
        $warehouse_id = (int)trim(Tools::getValue("warehouse_id"));
        //validation

        if(!is_numeric($warehouse_id) || $warehouse_id<1){
            echo json_encode(array("error"=>$this->_module->l("Incorrect warehouse.")));
            exit();
        }
        $warehouse = $this->_module->getWarehouse($warehouse_id);
        if($warehouse==false){
            echo json_encode(array("error"=>$this->_module->l("Incorrect warehouse (1).")));
            exit();
        }

        if(!is_numeric($weight)){
            echo json_encode(array("error"=>$this->_module->l("Incorrect weight.")));
            exit();
        }
        if(!is_numeric($pallets)){
            echo json_encode(array("error"=>$this->_module->l("Incorrect number of pallets.")));
            exit();
        }

        if($arrive_date==""){
            echo json_encode(array("error"=>$this->_module->l("Arrival time is required.")));
            exit();
        }

        if($hour_from=='' || $min_from=='' || $hour_to=='' || $min_to==''){
            echo json_encode(array("error"=>$this->_module->l("Arrival time is required.")));
            exit();
        }

        $format = "Y-m-d";
        $formatFull = "Y-m-d H:i:s";
        $testDate = DateTime::createFromFormat($format, $arrive_date);
        //if date is in not today - forbid to call another time for tomorrow
        if($testDate->format($format)!=date($format)){
            $checkFutureCall = $this->_module->getCarrierCallByDate($warehouse_id, $testDate->format($format));
            if(!empty($checkFutureCall)){
                echo json_encode(array("error"=>$this->_module->l("Cannot call another time in the future.")));
                exit();
            }
        }

        //check for 2 hours interval
        $testDateFrom = DateTime::createFromFormat($formatFull, $arrive_date.' '.$hour_from.':'.$min_from.':00');
        $testDateTo = DateTime::createFromFormat($formatFull, $arrive_date.' '.$hour_to.':'.$min_to.':00');
        $diff = $testDateTo->diff($testDateFrom, true);
        if($diff->h<2){
            echo json_encode(array("error"=>$this->_module->l("Interval must be at least 2 hours.")));
            exit();
        }

        if($comment!=''){
            //htmlspecialchars
            $comment = htmlspecialchars(strip_tags($comment));
        }
        //if we got this far, everything is ok
        if(!class_exists("VenipakAPI")){
            require_once(_PS_MODULE_DIR_.$this->_module->name.'/classes/VenipakAPI.php');
        }
        if(!empty($this->_module->warning)){
            return false;
        }
        $apiClass = new VenipakAPI($this->_module);
        $dataArray = array(
            'weight' => $weight,
            'pallets' => $pallets,
            'comment'=> $comment,
            'date_y' => $testDate->format('Y'),
            'date_m' => $testDate->format('m'),
            'date_d' => $testDate->format('d'),
            'hour_from' => $hour_from,
            'min_from' => $min_from,
            'hour_to' => $hour_to,
            'min_to' => $min_to
        );
        $result = $apiClass->callCourier($warehouse_id, $dataArray);
        //fix utf8 characters
        if(version_compare(PHP_VERSION, '5.4', '>=')){
            $dataArrayEncoded = json_encode($dataArray, JSON_UNESCAPED_UNICODE);
        }else{
            $dataArrayEncodedRaw = json_encode($dataArray);
            $dataArrayEncoded = preg_replace_callback('/\\\u(\w{4})/', function ($matches) {
                return html_entity_decode('&#x' . $matches[1] . ';', ENT_COMPAT, 'UTF-8');
            }, $dataArrayEncodedRaw);
        }
        

        if(!empty($result) && isset($result['success'])){
            //insert in database
            $insertResult = $this->_module->saveCarrierCall($warehouse_id, $testDate->format('Y-m-d'), $dataArrayEncoded);
        }

        if(isset($result['error'])){
            $result['status'] = 0;
        }else{
            $result['status'] = 1;
        }
        echo json_encode($result);
        exit();
    }

}